<?php
    /**
     * Include JavaScript widget
     * 
     * Allows you to insert any javascript code from a js file to your Wordpress widget
     * 
     * @author Debiprasad Sahoo
     * @version 1
     * @copyright Debiprasad Sahoo
     * @since 21 March 2009
     */
    /*
    Plugin Name: Include JavaScript Widget
    Plugin URI: http://dpstechno.blogspot.com/2009/03/javascript-sidebar-widget-plugin-for_21.html
    Description: This is a very simple sidebar widget which places javascript code in the widget. In this plugin, you need to provide the url of the javascript and this plugin will use that js file source.  
    Author: Debiprasad
    Version: 1
    Author URI: http://dpstechno.blogspot.com/
    */

    // Put functions into one big function we'll call at the plugins_loaded
    // action. This ensures that all required plugin functions are defined.
    function widget_includejs_init() {
    
    	// Check for the required plugin functions. This will prevent fatal
    	// errors occurring when you deactivate the dynamic-sidebar plugin.
    	if ( !function_exists('register_sidebar_widget') )
    		return;
    	
        // Options and default values for this widget
    	function widget_includejs_options() {
    		return array('Title'      => "",
    					 'URL' => "");
    	}

    	// This is the function that outputs the javascript code.
    	function widget_includejs($args) {
    		// $args is an array of strings that help widgets to conform to
    		// the active theme: before_widget, before_title, after_widget,
    		// and after_title are the array keys. Default tags: li and h2.
    		extract($args);
    
    		// Each widget can store and retrieve its own options.
    		// Here we retrieve any options that may have been set by the user
    		// relying on widget defaults to fill the gaps.
    		$options = array_merge(widget_includejs_options(), get_option('widget_includejs'));
    		unset($options[0]); //returned by get_option(), but we don't need it
    
    		// These lines generate our output. Widgets can be very complex
    		// but as you can see here, they can also be very, very simple.
    		echo $before_widget . $before_title . $options['Title'] . $after_title
    		   . "<script type=\"text/javascript\" src=\"" 
    		   . $options['URL'] 
    		   . "\"></script>"
    		   . $after_widget;
    	}
    	
    	// This is the function that outputs the form to let the users edit
    	// the widget's title. It's an optional feature that users cry for.
    	function widget_includejs_control() {
    		// Each widget can store and retrieve its own options.
    		// Here we retrieve any options that may have been set by the user
    		// relying on widget defaults to fill the gaps.
    		$options = array_merge(widget_includejs_options(), get_option('widget_includejs'));
    		unset($options[0]); //returned by get_option(), but we don't need it
    
    		// If user is submitting custom option values for this widget
    		if ( $_POST['includejs-submit'] ) {
    			// Remember to sanitize and format use input appropriately.
    			foreach($options as $key => $value)
    				if(array_key_exists('includejs-'.$key, $_POST))
    					$options[$key] = strip_tags(stripslashes($_POST['includejs-'.$key]));
    
    			// Save changes
    			update_option('widget_includejs', $options);
    		}
    
    		// Here is our little form segment. Notice that we don't need a
    		// complete form. This will be embedded into the existing form.
    		// Be sure you format your options to be valid HTML attributes
    		// before displayihng them on the page.
    		foreach($options as $key => $value): ?>
    			<p style="text-align:left"><label for="includejs-<?=$key?>"><?=$key?>: <input style="width: 200px;" id="includejs-<?=$key?>" name="includejs-<?=$key?>" type="text" value="<?=htmlspecialchars($value, ENT_QUOTES)?>" /></label></p>
    		<? endforeach;
    		echo '<input type="hidden" id="includejs-submit" name="includejs-submit" value="1" />';
    	}
    	
    	// This registers our widget so it appears with the other available
    	// widgets and can be dragged and dropped into any active sidebars.
    	register_sidebar_widget('includeJS Widget', 'widget_includejs');
    
    	// This registers our optional widget control form. Because of this
    	// our widget will have a button that reveals a 300x100 pixel form.
    	register_widget_control('includeJS Widget', 'widget_includejs_control', 220, 50 * count(widget_includejs_options()));
    }

    // Run our code later in case this loads prior to any required plugins.
    add_action('plugins_loaded', 'widget_includejs_init');